## dovecot-antispam 1.1+20090218.git.g28075fa

=== Makefile ===
# include config file
CONFIG ?= .config
-include $(CONFIG)
CFLAGSORIG := $(CFLAGS)
-include $(DOVECOT)/dovecot-config
INSTALLDIR ?= $(moduledir)/imap
# Kill CFLAGS from dovecot-config
CFLAGS := $(CFLAGSORIG)

# includes/flags we need for building a dovecot plugin
INCS += -DHAVE_CONFIG_H
INCS += -I$(DOVECOT)/
INCS += -I$(DOVECOT)/src/
INCS += -I$(DOVECOT)/src/lib/
INCS += -I$(DOVECOT)/src/lib-storage/
INCS += -I$(DOVECOT)/src/lib-mail/
INCS += -I$(DOVECOT)/src/lib-imap/
INCS += -I$(DOVECOT)/src/lib-dict/
INCS += -I$(DOVECOT)/src/lib-index/
INCS += -I$(DOVECOT)/src/imap/

# output name
LIBRARY_NAME ?= lib90_$(PLUGINNAME)_plugin.so

# debug rules
ifeq ("$(DEBUG)", "stderr")
CFLAGS += -DCONFIG_DEBUG -DDEBUG_STDERR
objs += debug.o
else 
ifeq ("$(DEBUG)", "syslog")
CFLAGS += -DCONFIG_DEBUG -DDEBUG_SYSLOG
objs += debug.o
endif
endif

ifeq ("$(DEBUG_VERBOSE)", "1")
CFLAGS += -DCONFIG_DEBUG_VERBOSE
endif

# backend error check
ifeq ("$(BACKEND)", "")
error: verify_config
	@echo "Error! no backend configured"
	@false
endif

# per-backend rules
ifeq ("$(BACKEND)", "dspam-exec")
objs += signature.o
endif
ifeq ("$(BACKEND)", "signature-log")
objs += signature.o
endif
ifeq ("$(BACKEND)", "crm114-exec")
objs += signature.o
endif

# main make rules
CFLAGS += -fPIC -shared -Wall -Wextra -DPLUGINNAME=$(PLUGINNAME)
CC ?= cc
HOSTCC ?= cc

objs += antispam-plugin.o antispam-storage.o $(BACKEND).o

all: verify_config $(LIBRARY_NAME)

antispam-storage.o: antispam-storage.c antispam-storage-*.c $(CONFIG) antispam-plugin.h dovecot-version.h
	$(CC) -c $(CFLAGS) $(INCS) -o $@ $<

%.o:	%.c $(CONFIG) antispam-plugin.h dovecot-version.h antispam-version.h
	$(CC) -c $(CFLAGS) $(INCS) -o $@ $<

$(LIBRARY_NAME): $(objs)
	$(CC) $(CFLAGS) $(INCS) $(objs) -o $(LIBRARY_NAME) $(LDFLAGS)

dovecot-version: dovecot-version.c $(CONFIG)
	$(HOSTCC) $(INCS) -o dovecot-version dovecot-version.c

dovecot-version.h: dovecot-version
	./dovecot-version > dovecot-version.h

antispam-version.h: version.sh
	./version.sh > antispam-version.h

clean:
	rm -f *.so *.o *~ dovecot-version dovecot-version.h antispam-version.h

install: all
	install -o $(USER) -g $(GROUP) -m 0755 $(LIBRARY_NAME) $(INSTALLDIR)/

verify_config:
	@if [ ! -r $(CONFIG) ]; then \
		echo -e "\nBuilding the plugin requires a configuration file"; \
		echo -e $(CONFIG)'. Copy defconfig ("cp defconfig' $(CONFIG)'")' ; \
		echo -e "to create an example configuration.\n"; \
		exit 1; \
	fi

## dovecot-antispam 1.2+20090702

=== Makefile ===
--- 
+++ 
@@ -86,7 +86,7 @@
 	rm -f *.so *.o *~ dovecot-version dovecot-version.h antispam-version.h
 
 install: all
-	install -o $(USER) -g $(GROUP) -m 0755 $(LIBRARY_NAME) $(INSTALLDIR)/
+	install -o $(USER) -g $(GROUP) -m 0755 $(LIBRARY_NAME) $(DESTDIR)$(INSTALLDIR)/
 
 verify_config:
 	@if [ ! -r $(CONFIG) ]; then \

## dovecot-antispam 1.4~rc3

=== Makefile ===
# include config file
CONFIG ?= .config
-include $(CONFIG)
CFLAGSORIG := $(CFLAGS)
-include $(DOVECOT)/dovecot-config
INSTALLDIR ?= $(moduledir)/imap
# Kill CFLAGS from dovecot-config
CFLAGS := $(CFLAGSORIG)

# includes/flags we need for building a dovecot plugin
INCS += -DHAVE_CONFIG_H
INCS += -I$(DOVECOT)/
INCS += -I$(DOVECOT)/src/
INCS += -I$(DOVECOT)/src/lib/
INCS += -I$(DOVECOT)/src/lib-storage/
INCS += -I$(DOVECOT)/src/lib-mail/
INCS += -I$(DOVECOT)/src/lib-imap/
INCS += -I$(DOVECOT)/src/lib-dict/
INCS += -I$(DOVECOT)/src/lib-index/
INCS += -I$(DOVECOT)/src/imap/

# output name
LIBRARY_NAME ?= lib90_$(PLUGINNAME)_plugin.so
objs = antispam-storage.o antispam-plugin.o

# debug rules
ifeq ("$(DEBUG)", "stderr")
LOCALCFLAGS += -DCONFIG_DEBUG -DDEBUG_STDERR
objs += debug.o
else 
ifeq ("$(DEBUG)", "syslog")
LOCALCFLAGS += -DCONFIG_DEBUG -DDEBUG_SYSLOG
objs += debug.o
endif
endif

ifeq ("$(DEBUG_VERBOSE)", "1")
LOCALCFLAGS += -DCONFIG_DEBUG_VERBOSE
endif

objs += dspam-exec.o signature-log.o crm114-exec.o pipe.o spool2dir.o signature.o

# main make rules
LOCALCFLAGS += -fPIC -shared -Wall -Wextra -DPLUGINNAME=$(PLUGINNAME)
CC ?= cc
HOSTCC ?= cc

all: verify_config $(LIBRARY_NAME)

antispam-storage.o: antispam-storage.c antispam-storage-*.c $(CONFIG) antispam-plugin.h dovecot-version.h
	$(CC) -c $(CFLAGS) $(LOCALCFLAGS) $(INCS) -o $@ $<

%.o: %.c $(CONFIG) antispam-plugin.h dovecot-version.h antispam-version.h
	$(CC) -c $(CFLAGS) $(LOCALCFLAGS) $(INCS) -o $@ $<

$(LIBRARY_NAME): $(objs)
	$(CC) $(CFLAGS) $(LOCALCFLAGS) $(INCS) $(objs) -o $(LIBRARY_NAME) $(LDFLAGS)

dovecot-version: dovecot-version.c $(CONFIG)
	$(HOSTCC) $(INCS) -o dovecot-version dovecot-version.c

dovecot-version.h: dovecot-version
	./dovecot-version > dovecot-version.h

antispam-version.h: version.sh
	./version.sh > antispam-version.h


clean:
	rm -f *.so *.o *~ dovecot-version dovecot-version.h antispam-version.h

install: all
	install -p -m 0755 $(LIBRARY_NAME) $(DESTDIR)$(INSTALLDIR)/

verify_config:
	@if [ ! -r $(CONFIG) ]; then \
		echo -e "\nBuilding the plugin requires a configuration file"; \
		echo -e $(CONFIG)'. Copy defconfig ("cp defconfig' $(CONFIG)'")' ; \
		echo -e "to create an example configuration.\n"; \
		exit 1; \
	fi

## dovecot-antispam 2.0%2B20171229

=== debian/changelog ===
dovecot-antispam (2.0+20171229-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Convert to source format 3.0.  Closes: #1007291

 -- Bastian Germann <bage@debian.org>  Thu, 27 Jun 2024 20:43:53 +0000

dovecot-antispam (2.0+20171229-1) unstable; urgency=medium

  * Support for dovecot 2.3 changes.
  * Support DEB_HOST_GNU_TYPE for cross building.  Thanks to Helmut Grohne for
    noticing that it didn't already.  Closes: #872426

 -- Ron Lee <ron@debian.org>  Mon, 23 Apr 2018 01:05:02 +0930

dovecot-antispam (2.0+20170109-1) unstable; urgency=medium

  * Make the debug prefix configurable.  The default remains "antispam: ", but
    you can now configure it to include, for example, the logged-in username.
    Closes: #692754

 -- Ron Lee <ron@debian.org>  Tue, 17 Jan 2017 17:13:06 +1030

dovecot-antispam (2.0+20170102-1) unstable; urgency=medium

  * This is what 2.0+20170101-1 actually should have been released as, and is
    what it was tagged with in git, but I typoed the changelog entry and didn't
    notice until after it was already uploaded.

 -- Ron Lee <ron@debian.org>  Fri, 06 Jan 2017 01:54:52 +1030

dovecot-antispam (2.0+20170101-1) unstable; urgency=medium

  * Fix mail_get_headers() return value usage to suit the changes made in
    dovecot 2.2.27.  The change here is backward compatible with earlier
    dovecot versions still.

  * Don't Suggest dspam anymore, the dspam package was abandoned upstream
    and dropped from Jessie.  Closes: #818794

 -- Ron Lee <ron@debian.org>  Fri, 06 Jan 2017 01:54:51 +1030

dovecot-antispam (2.0+20150222-1) unstable; urgency=medium

  * Use T_BEGIN/T_END since t_push() changed its signature and broke API
    in dovecot 2.2.14, and this is the interface to it that things were
    supposed to switch to some time back.  Closes: #765943

 -- Ron Lee <ron@debian.org>  Sat, 04 Jul 2015 10:30:53 +0930

dovecot-antispam (2.0+20130912-2) unstable; urgency=medium

  * Use the correct argc for pipe.ham_args

    This fixes a typo bug, where if the number of arguments set for
    antispam_pipe_program_spam_arg is not the same as what was set
    for antispam_pipe_program_notspam_arg, then we'll either scribble
    past the end of the allocated argv array, or populate it with
    pointers to whatever followed the real ham_args.

    Thanks to Peter Colberg who reported this, including a correct
    patch to fix it, to the security team.  The security implications
    of this seem somewhat limited, since you need to edit a config
    file as root to create the bad situation, and there is no path
    for remote injection of crafted data (whether it overflows or
    underflows) if you do, the argv array will just get some 'random'
    extra pointers to existing internal data.

    However it does pose a potential problem for a legitimate user
    who does legitimately need or want to pass a different number of
    arguments for the spam and ham cases, since that could crash
    dovecot, or confuse the hell out of their pipe program when it
    gets some random extra arguments.  It's probably gone unnoticed
    for this long because most uses will pass the same number of
    arguments for both of them, but that's not a necessary condition
    in the general case.

 -- Ron Lee <ron@debian.org>  Sun, 22 Feb 2015 09:27:51 +1030

dovecot-antispam (2.0+20130912-1) unstable; urgency=medium

  * Merge upstreamed patches from the upstream branch,
    no new changes to the Debian package from this.
  * Depend on dovecot ABI rather than a specific Dovecot package version.
    Many thanks to Jelmer Vernooij for both adding support for that to the
    dovecot package and providing a patch for this one to use it.  Now we
    just need dovecot upstream to start bumping ABI less often than version :)
    Closes: #755432

 -- Ron Lee <ron@debian.org>  Sat, 04 Oct 2014 16:08:32 +0930

dovecot-antispam (2.0+20130822-2) unstable; urgency=low

  * More updates for dovecot 2.2.  Thanks again to Micah for really testing
    it this time :)

 -- Ron Lee <ron@debian.org>  Thu, 12 Sep 2013 18:53:17 +0930

dovecot-antispam (2.0+20130822-1) unstable; urgency=low

  * Update for compatibility with dovecot 2.2.  Thanks to Micah for doing the
    legwork of testing and getting things patched.

 -- Ron Lee <ron@debian.org>  Sun, 08 Sep 2013 00:14:37 +0930

dovecot-antispam (2.0+20120225-3) unstable; urgency=low

  * Apply patch from Johannes for dovecot 2.1  Closes: #676007

 -- Ron Lee <ron@debian.org>  Wed, 20 Jun 2012 01:55:54 +0930

dovecot-antispam (2.0+20120225-2) unstable; urgency=low

  * Try that again with a dependency range that allows for the Debian version.

 -- Ron Lee <ron@debian.org>  Sun, 25 Mar 2012 03:37:09 +1030

dovecot-antispam (2.0+20120225-1) unstable; urgency=low

  * Pull in upstream patch to allow multiple spam/notspam arguments.
  * Fix dspam config in antispam.7 examples.  Closes: #663721
  * Hard depend on the version of dovecot this is built with.  Closes: #664616
    Maybe this will remind the dovecot maintainers to request a binNMU when they
    push a new upstream version, since asking nicely, repeatedly, hasn't helped.

 -- Ron Lee <ron@debian.org>  Sun, 25 Mar 2012 00:11:15 +1030

dovecot-antispam (2.0-2) unstable; urgency=low

  * Dovecot modules are now installed in $moduledir, the /imap subdirectory
    is gone with version 2.

 -- Ron Lee <ron@debian.org>  Sat, 26 Nov 2011 00:13:03 +1030

dovecot-antispam (2.0-1) unstable; urgency=low

  * Now with support for the dovecot 2.0 release.  Closes: #625188, #631143

 -- Ron Lee <ron@debian.org>  Fri, 11 Nov 2011 04:13:57 +1030

dovecot-antispam (1.4~rc3-1) unstable; urgency=low

  * Update the antispam_backend docs for crm114 and dspam.
    Reapply the mainline revert of the extra mail_plugins options,
    which was swallowed in the v1.4-rc2 merge.  Closes: #617273.

 -- Ron Lee <ron@debian.org>  Sat, 12 Mar 2011 15:59:16 +1030

dovecot-antispam (1.4~rc2-1) unstable; urgency=low



## dovecot-antispam 2.0+20150222

=== Makefile ===
# include config file if present
CONFIG ?= .config
-include $(CONFIG)
CFLAGSORIG := $(CFLAGS)
DOVECOT ?= /usr/include/dovecot
-include $(DOVECOT)/dovecot-config
INSTALLDIR ?= $(moduledir)/imap
# Kill CFLAGS from dovecot-config
CFLAGS := $(CFLAGSORIG)

# includes/flags we need for building a dovecot plugin
INCS += -DHAVE_CONFIG_H
INCS += -I$(DOVECOT)/
INCS += -I$(DOVECOT)/src/
INCS += -I$(DOVECOT)/src/lib/
INCS += -I$(DOVECOT)/src/lib-storage/
INCS += -I$(DOVECOT)/src/lib-mail/
INCS += -I$(DOVECOT)/src/lib-imap/
INCS += -I$(DOVECOT)/src/lib-dict/
INCS += -I$(DOVECOT)/src/lib-index/
INCS += -I$(DOVECOT)/src/imap/

# output name
LIBRARY_NAME ?= lib90_antispam_plugin.so
objs = antispam-storage.o antispam-plugin.o debug.o
objs += dspam-exec.o crm114-exec.o pipe.o spool2dir.o signature.o

# main make rules
LOCALCFLAGS += -fPIC -shared -Wall -Wextra
CC ?= cc
HOSTCC ?= cc

all: $(LIBRARY_NAME)

antispam-storage.o: antispam-storage.c antispam-storage-*.c antispam-plugin.h dovecot-version.h
	@echo "  CC  " $@
	@$(CC) -c $(CFLAGS) $(LOCALCFLAGS) $(INCS) -o $@ $<

%.o: %.c antispam-plugin.h dovecot-version.h antispam-version.h
	@echo "  CC  " $@
	@$(CC) -c $(CFLAGS) $(LOCALCFLAGS) $(INCS) -o $@ $<

$(LIBRARY_NAME): $(objs)
	@echo "  LD  " $(LIBRARY_NAME)
	@$(CC) $(CFLAGS) $(LOCALCFLAGS) $(INCS) $(objs) -o $(LIBRARY_NAME) $(LDFLAGS)

dovecot-version: dovecot-version.c
	$(HOSTCC) $(INCS) -o dovecot-version dovecot-version.c

dovecot-version.h: dovecot-version
	./dovecot-version > dovecot-version.h

antispam-version.h: version.sh
	./version.sh antispam-version.h


clean:
	rm -f *.so *.o *~ dovecot-version dovecot-version.h antispam-version.h

install: all checkinstalldir
	install -p -m 0755 $(LIBRARY_NAME) $(DESTDIR)$(INSTALLDIR)/

checkinstalldir:
	@if [ ! -d "$(DESTDIR)$(INSTALLDIR)/" ] ; then \
		echo "Installation directory $(DESTDIR)$(INSTALLDIR)/ doesn't exist," ; \
		echo "run make install INSTALLDIR=..." ; \
		exit 2 ; \
	fi

## dovecot-antispam 2.0+20171229

=== debian/control ===
Source: dovecot-antispam
Section: mail
Priority: optional
Maintainer: Ron Lee <ron@debian.org>
Build-Depends: debhelper (>= 9), dovecot-dev (>= 1:2.2.13-4)
Standards-Version: 4.1.4.1
Homepage: http://johannes.sipsolutions.net/Projects/dovecot-antispam
Vcs-Git: https://salsa.debian.org/ron/dovecot-antispam.git
Vcs-Browser: https://salsa.debian.org/ron/dovecot-antispam

Package: dovecot-antispam
Architecture: any
Depends: ${shlibs:Depends}, dovecot-imapd, dovecot-abi-${dovecot:ABI-Version}
Suggests: crm114
Description: Dovecot plugins for training spam filters
 dovecot-antispam watches designated spam folders and trains mail as spam or
 not-spam when it moves in or out of those folders respectively.
 .
 dovecot-antispam supports dspam, crm114, and generic training by mailing spam
 and non-spam to training addresses.  For crm114, it supports folders for the
 additional "unsure" classification, and trains when moving from there to spam
 or normal folders.

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright 2003 - 2018, Ron Lee.

SHELL = /bin/bash

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

clean:
	dh_testdir
	$(MAKE) clean || true
	$(RM) .config dovecot-antispam.7
	dh_clean


build: build-arch
build-arch: lib90_antispam_plugin.so
build-indep:

lib90_antispam_plugin.so:
	dh_testdir
	cp -f defconfig .config
	$(MAKE) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="-O2 -g"


install: install-arch

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_install lib90_antispam_plugin.so usr/lib/dovecot/modules
	ln -sf antispam.7 dovecot-antispam.7
	dh_installman dovecot-antispam.7

install-indep: build-indep


binary: binary-arch

binary-arch: DOVECOT_ABI_VERSION = $(shell cat /usr/share/dovecot/dovecot-abi)
binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol -- -V'dovecot:ABI-Version=$(DOVECOT_ABI_VERSION)'
	dh_md5sums
	dh_builddeb

binary-indep: install-indep


.PHONY: clean build build-arch build-indep	\
	binary binary-arch binary-indep		\
	install install-arch install-indep
